523. Continuous Subarray Sum (Medium)

Given a list of non-negative numbers and a target integer k, write a function to check if the array has a continuous subarray of size at least 2 that sums up to the multiple of k, that is, sums up to n*k where n is also an integer.

Example 1:

Input: [23, 2, 4, 6, 7],  k=6
Output: True
Explanation: Because [2, 4] is a continuous subarray of size 2 and sums up to 6.

Example 2:

Input: [23, 2, 6, 4, 7],  k=6
Output: True
Explanation: Because [23, 2, 6, 4, 7] is an continuous subarray of size 5 and sums up to 42.

Note:

  1. The length of the array won't exceed 10,000.
  2. You may assume the sum of all the numbers is in the range of a signed 32-bit integer.
Solution 1: HashSet O(n); O(k)
    /**
     * HashSet O(n); O(k)
     * There is really no need to use map, the required length is at least 2,
     * so we just need to insert the mod to set(用preMod记录上一次的mod后的结果) one iteration later.
     * the original problem can be converted to find sum_i and sum_j, j - i >= 2 and sum_i % k == sum_j % k
     */
    public boolean checkSubarraySum(int[] nums, int k) {
        if (nums == null) {
            return false;
        }

        Set<Integer> set = new HashSet<>();
        int sum = 0;
        int preMod = 0; //用preMod记录上一次的mod后的结果
        for (int i = 0; i < nums.length; i++) {
            sum += nums[i];
            int mod = k == 0 ? sum : sum % k; //k可能是0
            if (set.contains(mod)) {
                return true;
            }
            set.add(preMod);
            preMod = mod;
        }
        return false;
    }
Solution 2: HashMap O(n); O(k)
    /**
     * HashMap O(n); O(k)
     * We iterate through the input array exactly once, 
     * keeping track of the running sum mod k of the elements in the process.
     * If we find that a running sum value at index j has been previously seen 
     * before in some earlier index i in the array,
     * then we know that the sub-array (i,j] contains a desired sum.
     */
    public boolean checkSubarraySumB(int[] nums, int k) {
        Map<Integer, Integer> map = new HashMap<>();
        map.put(0, -1);
        int sum = 0;
        for (int i = 0; i < nums.length; i++) {
            sum += nums[i];
            if (k != 0) sum %= k;
            Integer prev = map.get(sum);
            if (prev != null) {
                if (i - prev > 1) return true;
            } else map.put(sum, i);
        }
        return false;
    }
Follow Up:

1.考虑negative number case http://www.1point3acres.com/bbs/thread-276237-1-1.html

我觉得解法已经可以解决存在负数的情况

results matching ""

    No results matching ""